<?

/*
      index.php f&uuml;r PHP Magazin Demos Admin-Bereich
      
      Aufgabe:
      	Der Administrationsbereich
      
		Benutzte Variablen:
			Aufruf:
           aktion   ggf. durchzuf&uuml;hrende Aktion
           bname    ggf. der gew&uuml;nschte Benutzername
           rname    ggf. der Realname
           pass     ggf. das Passwort
           bid      ggf. die Benutzer-ID
						

 */

// Session starten
session_start();

// Include-Datei f&uuml;r die Konfigurationsdaten
require("../lib/config.inc");

// Include-Dateien f&uuml;r verschiedene Funktionen
require("../lib/mysqlfunktionen.inc");
   // Datenbankfunktionen
require("../lib/sicherheit.inc");
   // Sicherheits-Funktionen
require("../lib/avatar.inc");
   // Funktionen f&uuml;r die Avatar-Nutzung

// Werte &uuml;bernehmen
$aktion = $_REQUEST["aktion"];
$bname  = htmlentities(strip_tags($_POST["bname"]));
$rname  = htmlentities(strip_tags($_POST["rname"]));
$pass   = htmlentities(strip_tags($_POST["pass"]));
$bid    = $_REQUEST["bid"];

// Datei mit den Sprachanpassungen einbinden
switch($_REQUEST["sprache"]) {
   case "de":
      include("../lib/sprache/de.inc");
      $getsprache = "sprache=de";
      $postsprache = "<input type=\"hidden\" name=\"sprache\" value=\"de\">  \n";
      $diesprache = "de";
   break;
   case "en":
      include("../lib/sprache/en.inc");
      $getsprache = "sprache=en";
      $postsprache = "<input type=\"hidden\" name=\"sprache\" value=\"en\">  \n";
      $diesprache = "en";
  break;
   default:
      include("../lib/sprache/".DEFAULTSPRACHE.".inc");
      $getsprache = "";
      $postsprache =  "";
      $diesprache = "nichts ausgew&auml;hlt";
   break;
}

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>PHP Magazin Demos - Administrationsbereich</title>
</head>

<body>

<h1>PHP Magazin Demos - Administrationsbereich</h1>

<p>
<b>Zum ping-Skript mit
<a href="ping1.php"><code>escapeshellarg()</code></a>
oder mit
<a href="ping2.php"><code>escapeshellcmd()</code></a>
und zum
<a href="backtick.php">Backtick-Operator-Skript</a>
zur Demonstration der nicht mehr vorhandenen OS Command Injection.</b>
</p>

<p>
Zum 
<a href="../backend/index.php?<? echo $getsprache; ?>">Backend</a>
oder zur
<a href="../index.php?<? echo $getsprache; ?>">Startseite</a>.
</p>

<hr>

<p>
Dieses Skript ist vor allem am Anfang ziemlich beschr&auml;nkt: Es
k&ouml;nnen Benutzer in der Datenbank gespeichert werden, einzelne Benutzer
k&ouml;nnen gel&ouml;scht und ihr Status (Autor/Leser sowie
freigegeben/gesperrt) gewechselt werden. 
</p>


<?

echo "Ausgew&auml;hlte Sprachdatei: ".$diesprache."<br> \n";

$ok = verbindeMitDB(); 
	// Verbindung zur Datenbank herstellen: Ohne DB geht nichts


if ($ok) {
   switch ($aktion) {
   case "eintragen":
      // einen neuen Benutzer eintragen
      if (testeToken("eintragen")) {
          // (Wahrscheinlich) kein CSRF-Angriff, Benutzer eintragen
          $query = "INSERT INTO benutzer_tabelle (Benutzer_Name, Real_Name, Passwort, istAutor, freigegeben)
                                values ('$bname', '$rname', '$pass', 1, 1)";
          if (!mysql_query($query)) {
             // MySQL-Fehler
             echo $err_sql_newuser;
             echo $err_sql.mysql_errno().": ".mysql_error()."<br> \n";
          } else {
             echo $suc_sql_newuser;
          }
      } else {
          echo $err_csrf;
      }
   break;
   case "loeschen":
      // Benutzer l&ouml;schen
      if (testeToken("loeschen")) {
          // (Wahrscheinlich) kein CSRF-Angriff, Benutzer l&ouml;schen
          if ($bid == 1) {
              echo $err_not_autor;
          } else { 
              $query = "DELETE FROM benutzer_tabelle WHERE Benutzer_ID=".$bid;   
              if (!mysql_query($query)) {
                  // MySQL-Fehler
                  echo $err_sql_deluser;
                  echo $err_sql.mysql_errno().": ".mysql_error()."<br> \n";
               } else {
                  echo $suc_sql_deluser;
               }
           }
      } else {
          echo $err_csrf;
      }
   break;
   case "wirdAutor":
      if (testeToken("wirdAutor")) {
          // (Wahrscheinlich) kein CSRF-Angriff, Benutzer zum Autor machen
          // Benutzer freigeben
          $query = "UPDATE benutzer_tabelle SET istAutor=1 WHERE Benutzer_ID=".$bid;   
          if (!mysql_query($query)) {
             // MySQL-Fehler
             echo $err_sql_toautor;
             echo $err_sql.mysql_errno().": ".mysql_error()."<br> \n";
          } else {
             echo $suc_sql_toautor;
          }
       } else {
           echo $err_csrf;
       }
   break;
   case "wirdBenutzer":
      // Benutzer freigeben
      if (testeToken("wirdBenutzer")) {
          // (Wahrscheinlich) kein CSRF-Angriff, Autor zu normalen Benutzer machen
          $query = "UPDATE benutzer_tabelle SET istAutor=0 WHERE Benutzer_ID=".$bid;   
          if (!mysql_query($query)) {
             // MySQL-Fehler
             echo $err_sql_touser;
             echo $err_sql.mysql_errno().": ".mysql_error()."<br> \n";
          } else {
             echo $suc_sql_touser;
          }
       } else {
           echo $err_csrf;
       }
   break;
   case "freigeben":
      // Benutzer freigeben
      if (testeToken("freigeben")) {
          // (Wahrscheinlich) kein CSRF-Angriff, Benutzer freigeben
          $query = "UPDATE benutzer_tabelle SET freigegeben=1 WHERE Benutzer_ID=".$bid;   
          if (!mysql_query($query)) {
             // MySQL-Fehler
             echo $err_sql_freeuser;
             echo $err_sql.mysql_errno().": ".mysql_error()."<br> \n";
          } else {
             echo $suc_sql_freeuser;
          }
       } else {
           echo $err_csrf;
       }
   break;
   case "sperren":
      // Benutzer freigeben
      if (testeToken("sperren")) {
          // (Wahrscheinlich) kein CSRF-Angriff, Benutzer sperren
          $query = "UPDATE benutzer_tabelle SET freigegeben=0 WHERE Benutzer_ID=".$bid;   
          if (!mysql_query($query)) {
             // MySQL-Fehler
             echo $err_sql_lockuser;
             echo $err_sql.mysql_errno().": ".mysql_error()."<br> \n";
          } else {
             echo $suc_sql_lockuser;
          }
       } else {
           echo $err_csrf;
       }
   break;
	default:
   break;
   }

   echo "<hr> \n <h2>Benutzer-Liste</h2> \n";
   echo "<p> \n";
   // Einfach ohne R&uuml;cksicht auf Verluste alle Benutzer ausgeben
   $query = "SELECT * FROM benutzer_tabelle ORDER BY Benutzer_ID"; 
   $result = mysql_query($query);
   if (!$result) {
      // Fehler beim Ergebnis
      echo $err_sql_getusers;
      echo $err_sql.mysql_errno().": ".mysql_error()."<br> \n";
   } else {
      // Jetzt kann es losgehen... 
      echo "<table border=\"1\"  cellpadding=\"5\"> \n";
      echo "<tr> \n";
      echo "<td>Benutzer-ID</td>\n";
      echo "<td>Benutzer-Name </td>\n";
      echo "<td>Real-Name</td>\n";
      echo "<td>Passwort</td>\n";
      echo "<td>Autor?</td>\n";
      echo "<td>Freigegeben?</td>\n";
      echo "<td>Avatar</td>\n";
      echo "</tr> \n";
      while ($row = mysql_fetch_array($result)) {
         $avatarBild = avatarFile($row["Benutzer_ID"]);
         if ($avatarBild == "") {
            // es gibt keinen Avatar
            $avatartag = "";
         } else {
            $avatartag = "<img src=\"../avatare/".$avatarBild."\">";
         }
         echo "<tr> \n";
         echo "<td>".$row["Benutzer_ID"]."</td> \n";
         echo "<td>".$row["Benutzer_Name"]."  \n";
         echo "<form action=\"index.php\" method=\"POST\"> \n";
         echo $postsprache;
         echo "<input type=\"hidden\" name=\"token\" value=\"".erzeugeToken("loeschen")."\"> \n";
         echo "<input type=\"hidden\" name=\"bid\" value=\"".$row["Benutzer_ID"]."\"> \n";
         echo "<input type=\"submit\" name=\"aktion\" value=\"loeschen\"> \n";
         echo "</form> \n";
         echo "</td> \n";
         echo "<td>".$row["Real_Name"]."</td> \n";
         echo "<td>".$row["Passwort"]."</td> \n";
         if ($row["istAutor"] == 1) {
             echo "<td>ja \n";
             echo "<form action=\"index.php\" method=\"POST\"> \n";
             echo $postsprache;
             echo "<input type=\"hidden\" name=\"token\" value=\"".erzeugeToken("wirdBenutzer")."\"> \n";
             echo "<input type=\"hidden\" name=\"bid\" value=\"".$row["Benutzer_ID"]."\"> \n";
             echo "<input type=\"submit\" name=\"aktion\" value=\"wirdBenutzer\"> \n";
             echo "</form> \n";
             echo "</td> \n";
         } else {
             echo "<td>nein \n";
             echo "<form action=\"index.php\" method=\"POST\"> \n";
             echo $postsprache;
             echo "<input type=\"hidden\" name=\"token\" value=\"".erzeugeToken("wirdAutor")."\"> \n";
             echo "<input type=\"hidden\" name=\"bid\" value=\"".$row["Benutzer_ID"]."\"> \n";
             echo "<input type=\"submit\" name=\"aktion\" value=\"wirdAutor\"> \n";
             echo "</form> \n";
             echo "</td> \n";
         }
         if ($row["freigegeben"] == 1) {
             echo "<td>ja \n";
             echo "<form action=\"index.php\" method=\"POST\"> \n";
             echo $postsprache;
             echo "<input type=\"hidden\" name=\"token\" value=\"".erzeugeToken("sperren")."\"> \n";
             echo "<input type=\"hidden\" name=\"bid\" value=\"".$row["Benutzer_ID"]."\"> \n";
             echo "<input type=\"submit\" name=\"aktion\" value=\"sperren\"> \n";
             echo "</form> \n";
             echo "</td> \n";
         } else {
             echo "<td>nein \n";
             echo "<form action=\"index.php\" method=\"POST\"> \n";
             echo $postsprache;
             echo "<input type=\"hidden\" name=\"token\" value=\"".erzeugeToken("freigeben")."\"> \n";
             echo "<input type=\"hidden\" name=\"bid\" value=\"".$row["Benutzer_ID"]."\"> \n";
             echo "<input type=\"submit\" name=\"aktion\" value=\"freigeben\"> \n";
             echo "</form> \n";
         }
         echo "<td>".$avatartag."</td> \n";
         echo "</tr> \n";
      }         
      echo "</table> \n";
   }
}

?>   

<hr> 

<h2>Neuen Autor eintragen</h2>

<form action="index.php" method="POST"> 
   <? echo $postsprache; ?>
   <input type="hidden" name="token" value="<? echo erzeugeToken("eintragen"); ?>">
   Benutzername: <br>
   <input type="text" name="bname" value="Benutzername" size="20" maxlength="250"> <br>
   Realname: <br>
   <input type="text" name="rname" value="Realname" size="20" maxlength="250"> <br>
   Passwort: <br>
   <input type="text" name="pass" value="Passwort" size="20" maxlength="250"> <br>
   <input type="submit" name="aktion" value="eintragen">
</form>

</body>
</html>