<?

/*
      index.php f&uuml;r PHP Magazin Demos
      
      Aufgabe:
      	Startseite
      
		Benutzte Variablen:
			Aufruf:
           aktion   ggf. durchzuf&uuml;hrende Aktion
           id       ggf. ID, f&uuml;r die die Aktion gilt
           titel    ggf. einzutragender Titel
           text     ggf. einzutragender Text
           benutzer ggf. neuer Benutzername
           real     ggf. dessen Realname
           passwort ggf. das Passwort
						

 */

// Session starten
session_start();

// Include-Datei f&uuml;r die Konfigurationsdaten
require("./lib/config.inc");

// Include-Dateien fr verschiedene Funktionen
require("./lib/mysqlfunktionen.inc");
   // Datenbankfunktionen
require("./lib/sicherheit.inc");
   // Sicherheits-Funktionen
require("./lib/avatar.inc");
   // Funktionen fr die Avatar-Nutzung

// Werte &uuml;bernehmen
$aktion   = $_REQUEST["aktion"];
$id       = (int) $_REQUEST["id"];
$titel    = htmlentities(strip_tags($_POST["titel"]));
$text     = strip_tags($_POST["text"], "<a><img><pre><p><b>");
$benutzer = $_REQUEST["benutzer"];
$real     = $_REQUEST["real"];
$passwort = $_REQUEST["passwort"];

if ($_REQUEST["aktion"] == "ausloggen") {
   if (testeGETToken("ausloggen")) {
      // (Wahrscheinlich) kein CSRF-Angriff, Benutzer eintragen
      // L&ouml;schen aller Session-Variablen.
      $_SESSION = array();

      // Session-Cookie l&ouml;schen
      if (ini_get("session.use_cookies")) {
          $params = session_get_cookie_params();
          setcookie(session_name(), '', time() - 42000, $params["path"], $params["domain"], $params["secure"], $params["httponly"]);
      }
      // L&ouml;schen der Session
      session_destroy();
      $ausgeloggt = true;
   } else {
      // M&ouml;glicher CSRF-Angriff erkannt! 
      $ausgeloggt = false;
   }
}

// Datei mit den Sprachanpassungen einbinden
switch($_REQUEST["sprache"]) {
   case "de":
      include("./lib/sprache/de.inc");
      $getsprache = "sprache=de";
      $postsprache = "<input type=\"hidden\" name=\"sprache\" value=\"de\">  \n";
      $diesprache = "de";
   break;
   case "en":
      include("./lib/sprache/en.inc");
      $getsprache = "sprache=en";
      $postsprache = "<input type=\"hidden\" name=\"sprache\" value=\"en\">  \n";
      $diesprache = "en";
   break;
   default:
      include("./lib/sprache/".DEFAULTSPRACHE.".inc");
      $getsprache = "";
      $postsprache =  "";
      $diesprache = "nichts ausgew&auml;hlt";
   break;
}


/* 
 * Dieser Block wurde nur fr die Demonstration der Remote File Inclusion bentigt,
 * er ist daher jetzt berflssig und nur noch zur Dokumentation vorhanden
 *
 * // include-Anweisung zur Template-Auswahl
 * $rfi = "";
 * if ( ($_COOKIE["template"]=="template1") OR ($_COOKIE["template"]=="template2")) {
 *     $rfi = $_COOKIE["template"];
 * }
 * if ($rfi != "") {
 *    include($rfi."/das/ist/dummes.php");
 * }
 */



?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>PHP Magazin Demos - Hauptseite</title>
</head>

<body>

<h1>PHP Magazin Demos - Hauptseite</h1>

<p>
Zum 
<a href="admin/index.php?<? echo $getsprache; ?>">Administrationsbereich</a> 
oder zum 
<a href="backend/index.php?<? echo $getsprache; ?>">Backend</a>.
</p>

<hr>

<p>
Dieses Skript ist vor allem am Anfang ziemlich beschr&auml;nkt: Es
k&ouml;nnen alle Eintr&auml;ge als Titelliste angezeigt werden, und
einzelne Eintr&auml;ge k&ouml;nnen komplett wieder ausgeben werden.
Au&szlig;erdem k&ouml;nnen sich die Besucher hier als Benutzer registrieren und
registrierte Benutzer sich einloggen. 
</p>


<?

echo "Ausgew&auml;hlte Sprachdatei: ".$diesprache."<br> \n";


if ($_SESSION["eingeloggt"]) {
    // Der Benutzer ist eingeloggt
    echo "Angemeldet als ".$_SESSION["benutzername"].".\n";
    echo "(<a href=\"index.php?aktion=ausloggen&token=".erzeugeToken("ausloggen")."&".$getsprache."\">Ausloggen</a>)  <br> \n";
}



$dbok = verbindeMitDB(); 
	// Verbindung zur Datenbank herstellen: Ohne DB geht nichts


if ($dbok) {
   switch ($aktion) {
   case "anzeigen":
      // anzeige des Texts mit der ID $id
      $query = "SELECT Titel, Angelegt, Text, AutorID FROM text_tabelle WHERE Text_ID = ".$id; 
      $result = mysql_query($query);
      if (!$result) {
         // Fehler beim Holen des Eintrags:
         echo $err_sql_gettext;
         echo $err_sql.mysql_errno().": ".mysql_error()."<br> \n";
      } else {
         $row = mysql_fetch_array($result);

         // Jetzt fehlt nur noch der Autorenname...
         $autorquery = "SELECT Benutzer_Name FROM benutzer_tabelle WHERE Benutzer_ID = ".$row["AutorID"];
         $autorresult = mysql_query($autorquery);
         if (!$result) {
            // Fehler beim Holen des Eintrags, aber da das nur ein Sch&ouml;nheitsfehler ist, kann er ignoriert werden
            $autor = "";
         } else {
            $autorrow = mysql_fetch_array($autorresult);
            $autor = $autorrow["Benutzer_Name"];
         }    

         $avatarBild = avatarFile($row["AutorID"]);
         if ($avatarBild == "") {
            // es gibt keinen Avatar
         } else {
            $avatartag = "<img src=\"avatare/".$avatarBild."\">";
         }
  
         echo "<h2>Der Eintrag:</h2> \n ";
         echo "<table width=\"80%\" border=\"2\" cellspacing=\"2\" cellpadding=\"2\"> \n ";
         echo "<tr> \n";
         echo "<td rowspan=\"2\" width=\"10%\"> ".$autor."<br>".$avatartag." </td> \n";
         echo "<td> ".$row["Titel"]." </td> \n";
         echo "<td> ".$row["Angelegt"]." </td> \n";
         echo "</tr> \n";
         echo "<tr> \n";
         echo "<td colspan=\"2\"> ".$row["Text"]." </td> \n";
         echo "</tr> \n";
         echo "</table> \n";
	   }

   break;
   case "einloggen":
      // Wenn magic_quotes_gpc aktiv ist, m&uuml;ssen die eingef&uuml;gten Backslash entfernt werden:
      if (get_magic_quotes_gpc()) {
         $benutzer = stripslashes($benutzer);
         $passwort = stripslashes($passwort);
      }
      // SQL-Sonderzeichen maskieren, dies ist erst nach der Verbindung mit der DB m&ouml;glich
      $benutzer =  mysql_real_escape_string($benutzer);
      $passwort =  mysql_real_escape_string($passwort);

      // Nachsehen, ob es die Kombination von Benutzername und Passwort gibt
      $query = "SELECT Benutzer_ID, freigegeben FROM benutzer_tabelle WHERE Benutzer_Name = '".$benutzer."' AND Passwort = '".$passwort."'";
      $result = mysql_query($query);
      if (!$result) {
         // Fehler beim Holen des Eintrags:
         echo $err_sql_login;
         echo $err_sql.mysql_errno().": ".mysql_error()."<br> \n";
      } else {
         $row = mysql_fetch_array($result);
         if ($row["freigegeben"] == 1) {
             echo "<b>Anmeldung als $benutzer erfolgreich!</b> \n";
             echo "(<a href=\"index.php?aktion=ausloggen&token=".erzeugeToken("ausloggen")."&".$getsprache."\">Ausloggen</a>)  <br>\n";
             $_SESSION["benutzerID"]    = $row["Benutzer_ID"];
             $_SESSION["benutzername"]  = $benutzer;
             $_SESSION["eingeloggt"]    = TRUE;
         } else {
             echo "<b>Anmeldung fehlgeschlagen - der Benutzer ist nicht freigegeben!</b> \n";
         }
	   }
   break;
   case "ausloggen":
      // Das eigentlich Ausloggen ist oben bereits passiert (damit der Session-Cookie gel&ouml;scht werden kann)
      if ($ausgeloggt) {
          echo "Ausloggen erfolgreich, die Session wurde gel&ouml;scht. \n";
      } 
      else {
          echo "<b>Fehler beim Ausloggen</b> \n";
      }       
   break;
   case "registrieren":
      // Wenn magic_quotes_gpc aktiv ist, m&uuml;ssen die eingef&uuml;gten Backslash entfernt werden:
      if (get_magic_quotes_gpc()) {
         $real = stripslashes($real);
         $benutzer = stripslashes($benutzer);
         $passwort = stripslashes($passwort);
      }
      // SQL-Sonderzeichen maskieren, dies ist erst nach der Verbindung mit der DB m&ouml;glich
      $real     =  mysql_real_escape_string($real);
      $benutzer =  mysql_real_escape_string($benutzer);
      $passwort =  mysql_real_escape_string($passwort);

      $query = "INSERT INTO benutzer_tabelle (Benutzer_Name, Real_Name, Passwort, istAutor, freigegeben)
                            values ('$benutzer', '$real', '$passwort', 0, 0)";                  
      if (!mysql_query($query)) {
         // MySQL-Fehler
         echo $err_sql_adduser;
         echo $err_sql.mysql_errno().": ".mysql_error()." \n";
      } else {
         // Benutzer angelegt
         echo "<b>Benutzer $benutzer angelegt und eingeloggt!</b> \n";
         echo "(<a href=\"index.php?aktion=ausloggen&token=".erzeugeToken("ausloggen")."&".$getsprache."\">Ausloggen</a>)  \n";
         $_SESSION["benutzerID"]    = mysql_insert_id();
         $_SESSION["benutzername"]  = $benutzer;
         $_SESSION["eingeloggt"]    = TRUE;
      }
   break;
	default:
   break;
   }

   echo "<hr> \n <h2>Die bisherigen Eintr&auml;ge</h2> \n";
   echo "<p> \n";
   // Einfach ohne R&uuml;cksicht auf Verluste alle Titel ausgeben
   $query = "SELECT * FROM text_tabelle ORDER BY Angelegt"; 
   $result = mysql_query($query);
   if (!$result) {
      // Fehler beim Ergebnis
      echo $err_sql_titelliste;
      echo $err_sql.mysql_errno().": ".mysql_error()."<br> \n";
   } else {
      // Jetzt kann es losgehen...
      while ($row = mysql_fetch_array($result)) {
         echo $row["Angelegt"]." : ";
         echo "<!-- ID: ".$row["Text_ID"]." -->  ";
         echo "<a href=\"index.php?aktion=anzeigen&id=".$row["Text_ID"]."&".$getsprache."\">".$row["Titel"]."</a>\n";
         echo "<br><br> \n";
      }         
   }

}

?>   

<table>
      <tr>
<?
if (!$_SESSION["eingeloggt"]) {
    // Der Benutzer ist nicht eingeloggt
    echo "<th>Als Benutzer einloggen:</th> \n";
    echo "<th width=10%></th> \n";
}
?>
           <th>Als neuer Benutzer registrieren</th>
       </tr>
    
       <tr>
<?
if (!$_SESSION["eingeloggt"]) {
    // Der Benutzer ist nicht eingeloggt
    echo "<td valign=top><form action=\"index.php\" method=\"POST\">  \n";
    echo $postsprache;
    echo "Benutzername:<br>  \n";
    echo "<input type=\"text\" name=\"benutzer\" value=\"gast\" size=\"20\" maxlength=\"50\">   <br> \n";
    echo "Passwort: <br> \n";
    echo "<input type=\"text\" name=\"passwort\" value=\"gast\" size=\"20\" maxlength=\"50\">   <br> \n";
    echo "<input type=\"submit\" name=\"aktion\" value=\"einloggen\"> \n";
    echo "</form> \n";
    echo "</td> \n";
    echo "<td></td> \n";
}
?>
           <td valign=top><form action="index.php" method="POST"> 
           <? echo $postsprache; ?>
               Realname: <br> 
               <input type="text" name="real" value="Realname" size="20" maxlength="50">   <br>
               Benutzername:<br> 
               <input type="text" name="benutzer" value="Benutzername" size="20" maxlength="50">   <br>
               Passwort: <br>
               <input type="text" name="passwort" value="Passwort" size="20" maxlength="50">   <br>
               <input type="submit" name="aktion" value="registrieren">
               </form>
            </td>
       </tr>
</table>


</body>
</html>