<?

/*
      index.php f&uuml;r PHP Magazin Demos Backend
      
      Aufgabe:
      	Startseite
      
		Benutzte Variablen:
			Aufruf:
           aktion   ggf. durchzuf&uuml;hrende Aktion
           id       ggf. ID, f&uuml;r die die Aktion gilt
           titel    ggf. einzutragender Titel
           text     ggf. einzutragender Text
           benutzer ggf. der einzuloggende Benutzer
           passwort ggf. dessen Passwort
						
 */

// Session starten
session_start();

// Include-Datei f&uuml;r die Konfigurationsdaten
require("../lib/config.inc");

// Include-Dateien f&uuml;r verschiedene Funktionen
require("../lib/sicherheit.inc");
   // Sicherheits-Funktionen
require("../lib/avatar.inc");
   // Funktionen f&uuml;r die Avatar-Nutzung

// Die Virenscan-Funktion
function virenscan($pfad) {
   // Diese Funktion "emuliert" einen Virenscan 
   echo "<p><font color=red>Virenscan in Arbeit</font><br> \n";
   if ($_REQUEST["sichtbar"] == "ja") {
      // Befehl mit Ausgabe
      system("echo ".$pfad);
   } else {
      exec("echo ".$pfad);
   }   
   echo "</p> \n";
   return true;
}

if ($_REQUEST["aktion"] == "ausloggen") {
   if (testeGETToken("ausloggen")) {
      // (Wahrscheinlich) kein CSRF-Angriff, Benutzer eintragen
      // L&ouml;schen aller Session-Variablen.
      $_SESSION = array();

      // Session-Cookie l&ouml;schen
      if (ini_get("session.use_cookies")) {
          $params = session_get_cookie_params();
          setcookie(session_name(), '', time() - 42000, $params["path"], $params["domain"], $params["secure"], $params["httponly"]);
      }
      // L&ouml;schen der Session
      session_destroy();
      $ausgeloggt = true;
   } else {
      // M&ouml;glicher CSRF-Angriff erkannt! 
      $ausgeloggt = false;
   }
}

// Datei mit den Sprachanpassungen einbinden
if (isset($_REQUEST["sprache"])) {
    // Es ist eine Sprachdatei ausgew&auml;hlt
    include("../lib/sprache/".$_REQUEST["sprache"].".inc");
    $getsprache = "sprache=".$_REQUEST["sprache"];
    $postsprache = "<input type=\"hidden\" name=\"sprache\" value=\"".$_REQUEST["sprache"]."\">  \n";
    $diesprache = $_REQUEST["sprache"];
}
 else {
    include("../lib/sprache/".DEFAULTSPRACHE.".inc");
    $getsprache = "";
    $postsprache =  "";
    $diesprache = "";
}



// Parameter &uuml;bernehmen:
$aktion   = $_REQUEST["aktion"];
$id       = (int) $_REQUEST["id"];
$titel    = htmlentities(strip_tags($_POST["titel"]));
$text     = strip_tags($_POST["text"], "<a><img><pre><p><b>");
$benutzer = $_REQUEST["benutzer"];
$passwort = $_REQUEST["passwort"];
$plugin   = $_REQUEST["plugin"];


// Variablen initialisieren
$ergebnis   = "";              // nimmt Fehlermeldungen etc. auf
$dbok       = false;           // noch gibt es keine Verbindung zur Datenbank
$eingeloggt = false;           // noch ist kein Benutzer eingeloggt

// Konstante definieren
define("IMBACKEND", "TRUE");

// Verbindung zur Datenbank herstellen: Ohne DB geht nichts
$connection = mysql_connect(HOSTNAME,USERNAME,PASSWORD);
if (!$connection) {
   // Keine Verbindung zu MySQL
	$ergebnis = $ergebnis."<br>Fehler bei der Verbindung mit MySQL: <br> \n MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
   $dbok = false;
} else {
   $test = mysql_select_db(DATENBANK);
   if (!$test) {
      // Keine Verbindung zur Datenbank
      $ergebnis =  $ergebnis."<br>Fehler bei der Verbindung mit der Datenbank: <br> \n MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
      $dbok = false;
   } else {
      $dbok = true;
	}
}

if ($dbok) {
   // Verbindung mit der Datenbank steht
   if ($aktion == "einloggen") {
      // Der Benutzer m&ouml;chte sich einloggen
   
      // Wenn magic_quotes_gpc aktiv ist, m&uuml;ssen die eingef&uuml;gten Backslash entfernt werden:
      if (get_magic_quotes_gpc()) {
         $benutzer = stripslashes($benutzer);
         $passwort = stripslashes($passwort);
      }
      // SQL-Sonderzeichen maskieren, dies ist erst nach der Verbindung mit der DB m&ouml;glich
      $benutzer =  mysql_real_escape_string($benutzer);
      $passwort =  mysql_real_escape_string($passwort);

      // Nachsehen, ob es die Kombination von Benutzername und Passwort gibt
      $query = "SELECT Benutzer_ID, istAutor, freigegeben FROM benutzer_tabelle WHERE (Benutzer_Name = '".$benutzer."') AND (Passwort = '".$passwort."')";
      $result = mysql_query($query);
      if (!$result) {
         // Fehler beim Holen des Eintrags:
         $ergebnis = $ergebnis."Fehler bei der Abfrage der Zugangsdaten: <br> \n MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
         $eingeloggt = false;
      } else {
         $row = mysql_fetch_array($result);
         if ($row["freigegeben"] == 1 ) {
             // Anmeldung erfolgreich, der Benutzer ist freigegeben
             if ($row["istAutor"] == 1) {
                 // Status OK, Benutzer akzeptiert
                 $_SESSION["PHPMagUserID"] = $row["Benutzer_ID"];
                 $_SESSION["PHPMagStatus"] = $row["istAutor"];
                 $_SESSION["eingeloggt"] = true;
                 $eingeloggt = true;
             } else {
                 // Zwar Benutzer, aber kein Autor => Pech gehabt
                 $ergebnis = $ergebnis."<b>Sie sind nur Benutzer, kein Autor!</b> <br> \n";
                 $eingeloggt = false;
             }                                                       
         } else {
             $ergebnis = $ergebnis."<b>Authentifizierung fehlgeschlagen!</b> <br> \n";
             $eingeloggt = false;
         }
	   }
   } elseif ($aktion == "ausloggen") {
      // Der Benutzer m&ouml;chte sich ausloggen
      // Das eigentlich Ausloggen ist oben bereits passiert (damit der Session-Cookie gel&ouml;scht werden kann)
      if ($ausgeloggt) {
          $ergebnis = $ergebnis."<b>Ausloggen war erfolgreich</b> <br> \n";
          $eingeloggt = false;
      } 
      else {
          $ergebnis = $ergebnis."<b>Fehler beim Ausloggen</b> <br> \n";
          $eingeloggt = true;
      }           
   } else {   
       // wenn sich der Benutzer weder ein- noch ausloggen will, ist er wohl schon eingeloggt
       $BenutzerID = $_SESSION["PHPMagUserID"];
       $BenutzerStatus = $_SESSION["PHPMagStatus"];
       if ( ($BenutzerID >= 0) AND ($BenutzerStatus == 1) ) {
          // Cookies vorhanden und Status OK, prima
          // Jetzt fehlt nur noch der Benutzername, nur der Vollst&auml;ndigkeit halber
          $query = "SELECT Benutzer_Name FROM benutzer_tabelle WHERE Benutzer_ID = ".$BenutzerID;
          $result = mysql_query($query);
          if (!$result) {
             // Fehler beim Holen des Eintrags, aber da das nur ein Sch&ouml;nheitsfehler ist, kann er ignoriert werden
          } else {
             $row = mysql_fetch_array($result);
             $benutzer = $row["Benutzer_Name"];
          }          
          $eingeloggt = true;
       } else {
          $eingeloggt = false;
       }
   }
} else {
   // keine Verbindung mit der Datenbank
   $eingeloggt = false;
}


?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>PHP Magazin Demos - Backend</title>
</head>

<body>

<h1>PHP Magazin Demos - Backend</h1>

<p>
Zum <a href="../admin/index.php?<? echo $getsprache; ?>">Administrationsbereich</a>,
zur <a href="../index.php?<? echo $getsprache; ?>">Startseite</a>
oder zum <a href="index.php?aktion=plugin2&<? echo $getsprache; ?>">weitergeleiteten</a> Backend-Plugin .
</p>

<hr>

<p> 
Dieses Skript ist vor allem am Anfang ziemlich beschr&auml;nkt: Es
k&ouml;nnen Daten in der Datenbank gespeichert werden, es k&ouml;nnen alle
Eintr&auml;ge als Titelliste angezeigt werden, und einzelne Eintr&auml;ge
k&ouml;nnen komplett wieder ausgeben oder gel&ouml;scht werden.
</p>

<p> 
Bisher wird dabei nur zwischen Autoren und Benutzern unterschieden: Nur
Autoren haben Zugriff auf das Backend, aber dort sind sie gleichberechtigt,
d.h. jeder Autor kann alle Texte l&ouml;schen. 
</p>

<hr>

<?

echo "Ausgew&auml;hlte Sprachdatei: ".$diesprache."<br> \n";


if ($eingeloggt) {
   echo "<p> \n Sie sind eingeloggt als Benutzer \"<b>$benutzer</b>\".\n";
   echo "(<a href=\"index.php?aktion=ausloggen&token=".erzeugeToken("ausloggen")."&".$getsprache."\">Ausloggen</a>) \n </p> \n <hr> \n";

   $avatarBild = avatarFile($_SESSION["PHPMagUserID"]);
   if ($aktion != "upload") {
      // Keinen Avatar und Upload-Formular anzeigen, wenn ein Upload l&auml;uft
      echo "<p> \n Ihr Avatar: <br>\n";
      if ($avatarBild == "") {
          // es gibt keinen Avatar
          echo "Es ist kein Avatar vorhanden. \n </p> \n";
      } else {
          echo "<img src=\"../avatare/".$avatarBild."\"></p> \n";
      }
   
      echo "<b>Einen Avatar hochladen (nur GIF- oder JPEG-Bilder): </b><br> \n";
      echo "<form action=\"index.php\" method=\"post\" enctype=\"multipart/form-date\"> \n";
      echo "   <input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"128000\"> \n";
      echo "   Ausgabe des Virenscans sichtbar: <br> \n";
      echo "   <input type=\"radio\" value=\"ja\" name=\"sichtbar\" checked> ja (system()-Aufruf) <br>\n";
      echo "   <input type=\"radio\" value=\"nein\" name=\"sichtbar\"> nein (exec()-Aufruf) <br>\n";
      echo "   <input type=\"file\" name=\"avatarupload\"> \n";
      echo "   <input type=\"submit\" name=\"aktion\" value=\"upload\"> \n";
      echo "</form> \n";
   }
   
   
   echo "\n <hr> \n";

   switch ($aktion) {
   case "anzeigen":
      // anzeige des Texts mit der ID $id
      $query = "SELECT Titel, Angelegt, Text, AutorID FROM text_tabelle WHERE Text_ID = ".$id; 
      $result = mysql_query($query);
      if (!$result) {
         // Fehler beim Holen des Eintrags:
         echo "Fehler beim Holen des Texts:<br> \n";
         echo "MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
      } else {
         $row = mysql_fetch_array($result);

         // Jetzt fehlt nur noch der Autorenname...
         $autorquery = "SELECT Benutzer_Name FROM benutzer_tabelle WHERE Benutzer_ID = ".$row["AutorID"];
         $autorresult = mysql_query($autorquery);
         if (!$result) {
            // Fehler beim Holen des Eintrags, aber da das nur ein Sch&ouml;nheitsfehler ist, kann er ignoriert werden
            $autor = "";
         } else {
            $autorrow = mysql_fetch_array($autorresult);
            $autor = $autorrow["Benutzer_Name"];
         }    

         $avatarBild = avatarFile($row["AutorID"]);
         if ($avatarBild == "") {
            // es gibt keinen Avatar
         } else {
            $avatartag = "<img src=\"../avatare/".$avatarBild."\">";
         }

         echo "<h2>Der Eintrag:</h2>";
         echo "<table width=\"80%\" border=\"2\" cellspacing=\"2\" cellpadding=\"2\"> \n ";
         echo "<tr> \n";
         echo "<td rowspan=\"2\" width=\"10%\"> ".$autor."<br>".$avatartag." </td> \n";
         echo "<td> ".$row["Titel"]." </td> \n";
         echo "<td> ".$row["Angelegt"]." </td> \n";
         echo "</tr> \n";
         echo "<tr> \n";
         echo "<td colspan=\"3\"> ".$row["Text"]." </td> \n";
         echo "</tr> \n";
         echo "</table> <br> \n";

         echo "<table width=\"80%\" border=\"0\" cellspacing=\"2\" cellpadding=\"2\"> \n ";
         echo "<tr> \n";
         echo "<td width=\"10%\"> ";
         echo "<form action=\"index.php\" method=\"POST\"> \n";
         echo $postsprache;
         echo "<input type=\"hidden\" name=\"token\" value=\"".erzeugeToken("loeschen")."\"> \n";
         echo "<input type=\"hidden\" name=\"id\" value=\"".$id."\"> \n";
         echo "<input type=\"submit\" name=\"aktion\" value=\"loeschen\"> \n";
         echo "</form> \n";
         echo "</td> \n";
         echo "<td width=\"10%\"> ";
         echo "<form action=\"index.php\" method=\"POST\"> \n";
         echo $postsprache;
         echo "<input type=\"hidden\" name=\"token\" value=\"".erzeugeToken("edit")."\"> \n";
         echo "<input type=\"hidden\" name=\"id\" value=\"".$id."\"> \n";
         echo "<input type=\"submit\" name=\"aktion\" value=\"edit\"> \n";
         echo "</form> \n";
         echo "</td> \n";
         echo "<td width=\"80%\"> &nbsp; </td> \n";
         echo "</tr> \n";
         echo "</table> <br> \n";
	   }
   break;
   case "eintragen":
      // Daten eintragen
      if (testeToken("neuerText")) {
          // (Wahrscheinlich) kein CSRF-Angriff, Text eintragen

          // Wenn magic_quotes_gpc aktiv ist, m&uuml;ssen die eingef&uuml;gten Backslash entfernt werden:
          if (get_magic_quotes_gpc()) {
             $titel = stripslashes($titel);
             $text  = stripslashes($text);
          }

          // SQL-Sonderzeichen maskieren, dies ist erst nach der Verbindung mit der DB m&ouml;glich
          $titel =  mysql_real_escape_string($titel);
          $text  =  mysql_real_escape_string($text);

          $query = "INSERT INTO text_tabelle (Titel, Text, AutorID)
                                values ('$titel', '$text', $BenutzerID)";
          if (!mysql_query($query)) {
             // MySQL-Fehler
             echo "Fehler beim Eintragen des neuen Texts:<br> \n";
             echo "MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
          } else {
             echo "<b>Text erfolgreich eingetragen!</b> <br> \n";
          }
      } else {
          echo $err_csrf;
      }
   break;
   case "loeschen":
      // Eintrag l&ouml;schen
      if (testeToken("loeschen")) {
          // (Wahrscheinlich) kein CSRF-Angriff, Text l&ouml;schen
          $query = "DELETE FROM text_tabelle WHERE Text_ID=".$id;   
          if (!mysql_query($query)) {
             // MySQL-Fehler
             echo "Fehler beim L&ouml;schen des Texts:<br> \n";
             echo "MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
          } else {
             echo "<b>Text erfolgreich gel&ouml;scht!</b> <br> \n";
          }
      } else {
          echo $err_csrf;
      }
   break;
   case "edit":
      // Editieren des Texts mit der ID $id
      if (testeToken("edit")) {
         // Zuerst muss der Text geholt werden:
         $query = "SELECT Titel, Text, AutorID FROM text_tabelle WHERE Text_ID = ".$id; 
         $result = mysql_query($query);
         if (!$result) {
            // Fehler beim Holen des Eintrags:
            echo "Fehler beim Holen des Texts:<br> \n";
            echo "MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
         } else {
            $row = mysql_fetch_array($result);
            // Jetzt haben wir den Text, aber darf der Benutzer ihn auch &auml;ndern?
            echo "<form action=\"index.php\" method=\"POST\"> \n"; 
            echo $postsprache;
            echo "<input type=\"hidden\" name=\"token\" value=\"".erzeugeToken("update")."\"> \n";
            echo "<input type=\"hidden\" name=\"id\" value=\"".$id."\"> \n";
            echo "   <input type=\"text\" name=\"titel\" value=\"".$row["Titel"]."\" size=\"80\" maxlength=\"250\"> \n";
            echo "   <br><br>  \n";
            echo "   <textarea rows=\"10\" cols=\"80\" name=\"text\">".$row["Text"]."</textarea> \n";
            echo "   <br><br> \n";
            echo "   <input type=\"submit\" name=\"aktion\" value=\"update\"> \n";
            echo "</form> \n\n";
         }  
      } else {
          echo $err_csrf;
      }
   break;
   case "update":
      // Aktualisieren des Texts mit der ID $id
      if (testeToken("update")) {
          // (Wahrscheinlich) kein CSRF-Angriff, Text aktualisieren

          // Wenn magic_quotes_gpc aktiv ist, m&uuml;ssen die eingef&uuml;gten Backslash entfernt werden:
          if (get_magic_quotes_gpc()) {
             $titel = stripslashes($titel);
             $text  = stripslashes($text);
          }

          // SQL-Sonderzeichen maskieren, dies ist erst nach der Verbindung mit der DB m&ouml;glich
          $titel =  mysql_real_escape_string($titel);
          $text  =  mysql_real_escape_string($text);

          $query = "UPDATE text_tabelle 
                    SET Titel=\"".$titel."\", Text=\"".$text."\"
                    WHERE Text_ID=".$id;
          if (!mysql_query($query)) {
             // MySQL-Fehler
             echo "Fehler beim Aktualisieren des Texts:<br> \n";
             echo "MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
          } else {
             echo "<b>Text erfolgreich aktualisiert!</b> <br> \n";
          }
      } else {
          echo $err_csrf;
      }     
   break;
   case "plugin2":
      // es wird das Plugin aufgerufen
      echo "<script>location.href = \"plugins/plugin2.php\";</script> \n";
   break;
   case "upload":
      // es wird ein Avatar heraufgeladen
      $avatarFehler = FALSE;
      $uploadfehler = $_FILES["avatarupload"]["error"];
      if ($uploadfehler != UPLOAD_ERR_OK) {
         // Fehler beim Upload
         echo "Fehler beim Hochladen der Datei:".$uploadfehler." ! <br> \n";
         $avatarFehler = TRUE;
      } 
      else {
         $tmpname = $_FILES["avatarupload"]["tmp_name"];
         if ( getImageSize($tmpname) == FALSE ) {
            echo "Das ist aber kein Bild! <br> Bitte nur GIF- oder JPEG-Bilder hochladen! <br> \n";
            $avatarFehler = TRUE;
         } else {
            // Die heraufgeladene Datei ist ein Bild und kann verwendet werden
            // jetzt auf Viren scannen
            $sauber = virenscan($tmpname);
            if ($sauber) {
               // kein Virus gefunden, Datei kann verwendet werden
               $originalname = $_FILES["avatarupload"]["name"];
               $path_parts = pathinfo($originalname);
               $extension = strtolower($path_parts['extension']);
               $neuerAvatar = $_SESSION["PHPMagUserID"].".".$extension;

               if ( ($extension == "gif") OR ($extension == "jpg") ) {
                  // Datei hat die richtige Extension
                  $verschieben = FALSE;
                  if ($avatarBild == "") {
                     // es gibt keinen Avatar, die Datei kann sofort verschoben werden
                     $verschieben = TRUE;
                  } else {
                     // es gibt bereits einen Avatar, der muss erst gel&ouml;scht werden
                     if (unlink(AVATARPFAD.$avatarBild) ) {
                        // L&ouml;schen des alten Avatars erfolgreich, die Datei kann verschoben werden
                        $verschieben = TRUE;
                     } else {
                        echo "Fehler beim L&ouml;schen des alten Avatar-Bilds! <br> \n";
                        $verschieben = FALSE;
                        $avatarFehler = TRUE;
                     }
                  }
   	   			if ($verschieben) {
	   	   		   // die Datei kann verschoben werden
		   	   		if (move_uploaded_file($tmpname, AVATARPFAD.$neuerAvatar)) {
   		   			   echo "Datei erfolgreich ins Avatar-Verzeichnis verschoben! <br> Ihr neuer Avatar: <br> \n";
	   		   		   echo "<img src=\"../avatare/".$neuerAvatar."\"></p> \n";
                        echo "<br><br><a href=\"lfi.php?lfi=../avatare/".$neuerAvatar."\">Demo</a> f&uuml;r eine Local File Inclusion.<br><br> \n";
   		   			} else {
                        echo "Fehler beim Verschieben der Datei ins Avatar-Verzeichnis! <br> \n";
                        $avatarFehler = TRUE;
		   		   	}
   		   		}
               } else {
                  echo "Bitte nur .GIF- oder .JPG-Dateien hochladen! <br> \n";
                  $avatarFehler = TRUE;
               }
            } else {
               echo "Diese Datei enth&auml;lt einen Virus! <br> \n";
               $avatarFehler = TRUE;
            }
            
         }
      }

      echo "<b>Einen Avatar hochladen (nur GIF- oder JPEG-Bilder): </b><br> \n";
      echo "<form action=\"index.php\" method=\"post\" enctype=\"multipart/form-date\"> \n";
      echo "   <input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"128000\"> \n";
      echo "   Ausgabe des Virenscans sichtbar: <br> \n";
      echo "   <input type=\"radio\" value=\"ja\" name=\"sichtbar\" checked> ja (system()-Aufruf) <br>\n";
      echo "   <input type=\"radio\" value=\"nein\" name=\"sichtbar\"> nein (exec()-Aufruf) <br>\n";
      echo "   <input type=\"file\" name=\"avatarupload\"> \n";
      echo "   <input type=\"submit\" name=\"aktion\" value=\"upload\"> \n";
      echo "</form> \n";
   break;
	default:
   break;
   }

   // ggf. Plugin einbinden
   if (isset($_REQUEST["plugin"])) {
       // Es ist ein Plugin ausgew&auml;hlt
       include("plugins/".$_REQUEST["plugin"].".php");
   }
    else {
       // kein Plugin einbinden
   }

   echo "<hr> \n <h2>Die bisherigen Eintr&auml;ge</h2> \n";
   echo "<p> \n";
   // Einfach ohne R&uuml;cksicht auf Verluste alle Titel ausgeben
   $query = "SELECT * FROM text_tabelle ORDER BY Angelegt"; 
   $result = mysql_query($query);
   if (!$result) {
      // Fehler beim Ergebnis
      echo "<br>Fehler beim Holen der Texte:<br> \n";
      echo "MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
   } else {
      // Jetzt kann es losgehen...
      while ($row = mysql_fetch_array($result)) {
         echo $row["Angelegt"]." : ";
         echo "<!-- ID: ".$row["Text_ID"]." -->  ";
         echo "<a href=\"index.php?aktion=anzeigen&id=".$row["Text_ID"]."&".$getsprache."\">".$row["Titel"]."</a>\n";
         echo "<br><br> \n";
      }  
   }
   
   echo "<hr> \n <h2>Neuen Eintrag eingeben:</h2> \n\n";
   echo "<p>\n Autor: <b>$benutzer</b></p>\n";
   echo "<form action=\"index.php\" method=\"POST\"> \n"; 
   echo $postsprache;
   echo "<input type=\"hidden\" name=\"token\" value=\"".erzeugeToken("neuerText")."\"> \n";
   echo "   <input type=\"text\" name=\"titel\" value=\"Der Titel\" size=\"80\" maxlength=\"250\"> \n";
   echo "   <br><br>  \n";
   echo "   <textarea rows=\"10\" cols=\"80\" name=\"text\">Der Text</textarea> \n";
   echo "   <br><br> \n";
   echo "   <input type=\"submit\" name=\"aktion\" value=\"eintragen\"> \n";
   echo "</form> \n\n";
      
   } else {
       // Keine Verbindung mit der Datenbank oder Fehler beim Einloggen
       echo $ergebnis;
       echo "<b>Bitte loggen Sie sich ein!</b> <br> \n";
       echo "\n\n <hr> \n\n";
       echo "<h2>Als Autor einloggen:</h2> \n";
       echo "<form action=\"index.php\" method=\"POST\"> \n";
       echo $postsprache;
       echo "Benutzername:<br> \n";
       echo "<input type=\"text\" name=\"benutzer\" value=\"autor\" size=\"20\" maxlength=\"50\"> <br> \n";
       echo "Passwort: <br> \n";
       echo "<input type=\"text\" name=\"passwort\" value=\"autor\" size=\"20\" maxlength=\"50\"> <br>\n";
       echo "<input type=\"submit\" name=\"aktion\" value=\"einloggen\"> \n";
       echo "</form> \n";
}


?>   


</body>
</html>